unit DataMod;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, DBGrids, QueryDialog;

type
  TOrderDataModule = class(TDataModule)
    OrderQuery: TQuery;
    OrderQueryOrderNo: TFloatField;
    OrderQueryCustNo: TFloatField;
    OrderQuerySaleDate: TDateTimeField;
    OrderQueryShipDate: TDateTimeField;
    OrderQueryEmpNo: TIntegerField;
    OrderQueryShipToContact: TStringField;
    OrderQueryShipToAddr1: TStringField;
    OrderQueryShipToAddr2: TStringField;
    OrderQueryShipToCity: TStringField;
    OrderQueryShipToState: TStringField;
    OrderQueryShipToZip: TStringField;
    OrderQueryShipToCountry: TStringField;
    OrderQueryShipToPhone: TStringField;
    OrderQueryShipVIA: TStringField;
    OrderQueryPO: TStringField;
    OrderQueryTerms: TStringField;
    OrderQueryPaymentMethod: TStringField;
    OrderQueryItemsTotal: TCurrencyField;
    OrderQueryTaxRate: TFloatField;
    OrderQueryFreight: TCurrencyField;
    OrderQueryAmountPaid: TCurrencyField;
    OrderSource: TDataSource;
    Items: TQuery;
    ItemsOrderNo: TFloatField;
    ItemsItemNo: TFloatField;
    ItemsPartNo: TFloatField;
    ItemsQty: TIntegerField;
    ItemsDiscount: TFloatField;
    ItemSource: TDataSource;
    Customers: TQuery;
    CustomersCustNo: TFloatField;
    CustomersCompany: TStringField;
    CustomersAddr1: TStringField;
    CustomersAddr2: TStringField;
    CustomersCity: TStringField;
    CustomersState: TStringField;
    CustomersZip: TStringField;
    CustomersCountry: TStringField;
    CustomersPhone: TStringField;
    CustomersFAX: TStringField;
    CustomersTaxRate: TFloatField;
    CustomersContact: TStringField;
    CustomersLastInvoiceDate: TDateTimeField;
    CustomerSource: TDataSource;
    Employee: TQuery;
    EmployeeEmpNo: TIntegerField;
    EmployeeLastName: TStringField;
    EmployeeFirstName: TStringField;
    EmployeePhoneExt: TStringField;
    EmployeeHireDate: TDateTimeField;
    EmployeeSalary: TFloatField;
    EmpSource: TDataSource;
    OrderQueryDialog: TQueryDialog;
    DataSetQueryDialog: TQueryDialog;
    ItemQueryDialog: TQueryDialog;
    procedure OrderDataModuleCreate(Sender: TObject);
    procedure OrderQueryDialogMDIResultOK(Sender: TObject);
    procedure DataSetQueryDialogMDIResultOK(Sender: TObject);
    procedure ItemQueryDialogMDIResultOK(Sender: TObject);
  private
    { Private declarations }
  public
    procedure QueryOrders(FormToQuery: TForm);
    procedure QueryItems(GridToQuery: TDBGrid);
    procedure QueryOrdersDataSet;
  end;

var
  OrderDataModule: TOrderDataModule;

implementation

{$R *.DFM}

procedure TOrderDataModule.OrderDataModuleCreate(Sender: TObject);
begin
	OrderQuery.Open;
	Items.Open;
    Customers.Open;
    Employee.Open;
end;
//----------------------------------------------------------------------------
procedure TOrderDataModule.QueryOrders(FormToQuery: TForm);
begin
	OrderQueryDialog.DialogTitle := 'Query Orders Table From Form';
	OrderQueryDialog.Execute(FormToQuery);
end;
//----------------------------------------------------------------------------
procedure TOrderDataModule.QueryItems(GridToQuery: TDBGrid);
begin
	ItemQueryDialog.DialogTitle := 'Query Items Table From DBGrid';
	ItemQueryDialog.Execute(GridToQuery);
end;
//----------------------------------------------------------------------------
procedure TOrderDataModule.QueryOrdersDataSet;
begin
	DataSetQueryDialog.DialogTitle := 'Query Orders Table From TQuery';
	DataSetQueryDialog.Execute(OrderQuery);
end;
//----------------------------------------------------------------------------

procedure TOrderDataModule.OrderQueryDialogMDIResultOK(Sender: TObject);
begin
		OrderQuery.Close;

        if OrderQuery.SQL.Count > 1 then
        	OrderQuery.SQL.Delete(1);

        if OrderQueryDialog.QueryString <> '' then
        	OrderQuery.SQL.Add('where ' + OrderQueryDialog.QueryString);

    	OrderQuery.Open;

end;
//---------------------------------------------------------------------------

procedure TOrderDataModule.DataSetQueryDialogMDIResultOK(Sender: TObject);
begin
		OrderQuery.Close;

        if OrderQuery.SQL.Count > 1 then
        	OrderQuery.SQL.Delete(1);

        if DataSetQueryDialog.QueryString <> '' then
        	OrderQuery.SQL.Add('where ' + DataSetQueryDialog.QueryString);

    	OrderQuery.Open;
end;
//---------------------------------------------------------------------------

procedure TOrderDataModule.ItemQueryDialogMDIResultOK(Sender: TObject);
begin
		OrderQuery.Close;

        if OrderQuery.SQL.Count > 1 then
        	OrderQuery.SQL.Delete(1);

        if ItemQueryDialog.QueryString <> '' then
        	OrderQuery.SQL.Add('where orderno in (select orderno from items where ' + ItemQueryDialog.QueryString + ')');

    	OrderQuery.Open;
end;
//---------------------------------------------------------------------------

end.
