unit DataMod;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, QueryDialog, DBTables, DBGrids;

type
  TOrderDataModule = class(TDataModule)
    OrderQuery: TQuery;
    OrderQueryOrderNo: TFloatField;
    OrderQueryCustNo: TFloatField;
    OrderQuerySaleDate: TDateTimeField;
    OrderQueryShipDate: TDateTimeField;
    OrderQueryEmpNo: TIntegerField;
    OrderQueryShipToContact: TStringField;
    OrderQueryShipToAddr1: TStringField;
    OrderQueryShipToAddr2: TStringField;
    OrderQueryShipToCity: TStringField;
    OrderQueryShipToState: TStringField;
    OrderQueryShipToZip: TStringField;
    OrderQueryShipToCountry: TStringField;
    OrderQueryShipToPhone: TStringField;
    OrderQueryShipVIA: TStringField;
    OrderQueryPO: TStringField;
    OrderQueryTerms: TStringField;
    OrderQueryPaymentMethod: TStringField;
    OrderQueryItemsTotal: TCurrencyField;
    OrderQueryTaxRate: TFloatField;
    OrderQueryFreight: TCurrencyField;
    OrderQueryAmountPaid: TCurrencyField;
    QueryDialog: TQueryDialog;
    Items: TQuery;
    ItemsOrderNo: TFloatField;
    ItemsItemNo: TFloatField;
    ItemsPartNo: TFloatField;
    ItemsQty: TIntegerField;
    ItemsDiscount: TFloatField;
    Customers: TQuery;
    CustomersCustNo: TFloatField;
    CustomersCompany: TStringField;
    CustomersAddr1: TStringField;
    CustomersAddr2: TStringField;
    CustomersCity: TStringField;
    CustomersState: TStringField;
    CustomersZip: TStringField;
    CustomersCountry: TStringField;
    CustomersPhone: TStringField;
    CustomersFAX: TStringField;
    CustomersTaxRate: TFloatField;
    CustomersContact: TStringField;
    CustomersLastInvoiceDate: TDateTimeField;
    Employee: TQuery;
    EmployeeEmpNo: TIntegerField;
    EmployeeLastName: TStringField;
    EmployeeFirstName: TStringField;
    EmployeePhoneExt: TStringField;
    EmployeeHireDate: TDateTimeField;
    EmployeeSalary: TFloatField;
    OrderSource: TDataSource;
    ItemSource: TDataSource;
    CustomerSource: TDataSource;
    EmpSource: TDataSource;
    procedure OrderDataModuleCreate(Sender: TObject);
  private
    { Private declarations }
  public
	procedure QueryOrders(FormToQuery: TForm);
    procedure QueryItems(GridToQuery: TDBGrid);
    procedure QueryOrdersDataSet;
  end;

var
  OrderDataModule: TOrderDataModule;

implementation

{$R *.DFM}

procedure TOrderDataModule.OrderDataModuleCreate(Sender: TObject);
begin
	OrderQuery.Open;
	Items.Open;
    Customers.Open;
    Employee.Open;
end;
//----------------------------------------------------------------------------
procedure TOrderDataModule.QueryOrders(FormToQuery: TForm);
begin
	QueryDialog.DialogTitle := 'Query Orders Table From Form';
	if QueryDialog.Execute(FormToQuery) then
    begin
        OrderQuery.Close;

        if OrderQuery.SQL.Count > 1 then
        	OrderQuery.SQL.Delete(1);

        if QueryDialog.QueryString <> '' then
        	OrderQuery.SQL.Add('where ' + QueryDialog.QueryString);

    	OrderQuery.Open;
    end;
end;
//----------------------------------------------------------------------------
procedure TOrderDataModule.QueryItems(GridToQuery: TDBGrid);
begin
	QueryDialog.DialogTitle := 'Query Items Table From DBGrid';
	if QueryDialog.Execute(GridToQuery) then
    begin
        OrderQuery.Close;

        if OrderQuery.SQL.Count > 1 then
        	OrderQuery.SQL.Delete(1);

        if QueryDialog.QueryString <> '' then
        	OrderQuery.SQL.Add('where orderno in (select orderno from items where ' + QueryDialog.QueryString + ')');

    	OrderQuery.Open;
    end;
end;
//----------------------------------------------------------------------------
procedure TOrderDataModule.QueryOrdersDataSet;
begin
	QueryDialog.DialogTitle := 'Query Orders Table From TQuery';
	if QueryDialog.Execute(OrderQuery) then
    begin
        OrderQuery.Close;

        if OrderQuery.SQL.Count > 1 then
        	OrderQuery.SQL.Delete(1);

        if QueryDialog.QueryString <> '' then
        	OrderQuery.SQL.Add('where ' + QueryDialog.QueryString);

    	OrderQuery.Open;
    end;
end;

end.
